/*
 * socket.h
 */


#ifndef sys_socket_h
#define sys_socket_h


#include<sys/uio.h>
#include<share/socket.h>


struct sockaddr_storage{
	sa_family_t   ss_family;
};

struct msghdr{
	void          *msg_name;		/* Optional address. */
	socklen_t      msg_namelen;		/* Size of address. */
	struct iovec  *msg_iov;			/* Scatter/gather array. */
	int            msg_iovlen;		/* Members in msg_iov. */
	void          *msg_control;		/* Ancillary data; see below. */
	socklen_t      msg_controllen;	/* Ancillary data buffer len. */
	int            msg_flags;		/* Flags on received message. */
};

struct cmsghdr{
	socklen_t  cmsg_len;	/* Data byte count, including the cmsghdr. */
	int        cmsg_level;	/* Originating protocol. */
	int        cmsg_type;	/* Protocol-specific type. */
};

struct linger{
	int  l_onoff;	/* Indicates whether linger option is enabled. */
	int  l_linger;	/* Linger time, in seconds. */
};


ssize_t recvfrom(int, void *, size_t, int,struct sockaddr *, socklen_t *);
ssize_t sendto(int, const void *, size_t, int, const struct sockaddr *,socklen_t);
int     socket(int, int, int);
ushort calcSum(uint*,int);

/* ̤ */
int     accept(int, struct sockaddr *, socklen_t *);
int     bind(int, const struct sockaddr *, socklen_t);
int     connect(int, const struct sockaddr *, socklen_t);
int     getpeername(int, struct sockaddr *, socklen_t *);
int     getsockname(int, struct sockaddr *, socklen_t *);
int     getsockopt(int, int, int, void *, socklen_t *);
int     listen(int, int);
ssize_t recv(int, void *, size_t, int);
ssize_t recvmsg(int, struct msghdr *, int);
ssize_t send(int, const void *, size_t, int);
ssize_t sendmsg(int, const struct msghdr *, int);
int     setsockopt(int, int, int, const void *, socklen_t);
int     shutdown(int, int);
int     sockatmark(int);
int     socketpair(int, int, int, int[2]);


#endif
