/*
 * socket.c
 *
 * Copyright 2004, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#include<unistd.h>
#include<sys/types.h>
#include<callgate.h>
#include<system.h>
#include<share/syscall.h>
#include<errno.h>
#include<sys/socket.h>
#include<share/ip.h>


int socket(int domain, int type, int protocol)
{
	int rest;


	if(type==SOCK_RAW)
	{
		if(getuid()!=0)return -EACCES;
	}

	if((rest=syscall4(SYS_SOCKET,domain,type,protocol))<0)
	{
		errno=-rest;
		return -1;
	}
	return rest;
}


ssize_t sendto(int s, const void *msg, size_t len, int flags, const struct sockaddr *to, socklen_t tolen)
{
	int rest;


	if(s<0)
	{
		errno=EBADF;
		return -1;
	}

	if(tolen<sizeof(struct sockaddr)+4)
	{
		errno=EINVAL;
		return -1;
	}

	if((rest=syscall6(SYS_SEND,s,(int)msg,len,flags,(int)to))<0)
	{
		errno=-rest;
		return -1;
	}

	return rest;
}


ssize_t recvfrom(int s, void *buf, size_t len, int flags, struct sockaddr *from, socklen_t *fromlen)
{
	int rest;


	if(s<0)
	{
		errno=EBADF;
		return -1;
	}

	if((rest=syscall7(SYS_RECV,s,(int)buf,len,flags,(int)from,(int)fromlen))<0)
	{
		errno=-rest;
		return -1;
	}

	return rest;
}


/*
 * åη׻
 * parameters : data1 address,data2 address,byte size1,byte size2
 * return : פ
 */
ushort calcSum(uint *data,int size)
{
	union{
		unsigned long long u64;
		uint               u32[2];
		ushort             u16[4];
	}sum;
	uint tmp;


	sum.u64=0;
	for(;size>=sizeof(uint);size-=sizeof(uint))
		sum.u64+=*data++;
	if(size>0)sum.u64+=*data&((1<<(size*8))-1);

	tmp=sum.u32[1];
	sum.u32[1]=0;
	sum.u64+=tmp;
	tmp=sum.u32[1];
	sum.u32[1]=0;
	sum.u32[0]+=tmp;

	tmp=sum.u16[1];
	sum.u16[1]=0;
	sum.u32[0]+=tmp;
	tmp=sum.u16[1];
	sum.u16[1]=0;
	sum.u16[0]+=tmp;

	return ~sum.u16[0];
}
